# ////////////////////////////////////////////////////////////////////////////
# //
# //  D SOFTWARE INCORPORATED
# //  Copyright 2007-2014 D Software Incorporated
# //  All Rights Reserved.
# //
# //  NOTICE: D Software permits you to use, modify, and distribute this file
# //  in accordance with the terms of the license agreement accompanying it.
# //
# //  Unless required by applicable law or agreed to in writing, software
# //  distributed under the License is distributed on an "AS IS" BASIS,
# //  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# //
# ////////////////////////////////////////////////////////////////////////////
#
# This is a sample of what can be done by using API with Zephyr for JIRA through the Python coding language.
# The goal of the sample is to create a new test cycle and add existing test issues into it
# 
# IDLE IDE - Version: 2.7.5
# Python - Version: 2.7.5
# Requests - Version: 2.3.0
# 
# Author: Daniel Gannon, Technical Support Analyst, D Software Inc.

# Import libraries
from requests import post, get
from urllib import urlencode
from base64 import b64encode
from os import chdir

# Variables used:
baseURL = 'http://localhost:8080/'
username = 'test.manager'
password = 'test.manager'
issueId = 10183
# Possible types: EXECUTION, TESTSTEPRESULT
entityType = 'EXECUTION'
# ID of the entityType you are uploading to
# Execution = scheduleId, TestStepResult = testStepId
# One way to get scheduleId is detailed below
# Initialized to 0 for looping purposes
entityId = 0
fileSysLoc = 'C:\\'
filename = 'results.xml'
fileEntity = 'results.xml'

# ///// Get latest scheduleId from issueId /////
# Demonstrate one way to get scheduleId with ZAPI by returning all executions of a issue

# 'headers' holds information to be sent with the JSON data set
values = {
    "issueId": issueId
}

url = baseURL + "rest/zapi/latest/execution" + "?" + urlencode(values)

print "Searching for latest execution of issue: " + str(issueId) + "..."

response = get(url, auth=(username, password))
executions = response.json()
executions = executions['executions']

# Find latest execution by finding the largest scheduleId in the return
for x in executions:
    if x['id'] > entityId:
        entityId = x['id']

print "Latest execution found! Proceeding to upload attachment..."

# ///// Upload Attachment to Entity By ID /////
# Grab file from system location and upload it to JIRA via ZAPI request

# Required headers
headers = {"Authorization": "Basic " + b64encode(username + ":" + password),
           "X-Atlassian-Token": "nocheck", "Accept": "application/json"}

# Complete URL
url = baseURL + "rest/zapi/latest/attachment?entityId="+str(entityId)+"&entityType="+entityType

print "Grabbing file from file fystem..."

# Upload file from this location
chdir(fileSysLoc)

# Create file list with file from location provided
f = open(fileEntity, 'rb')
files = {'file':(filename, f, "multipart/form-data")}

print "Uploading file..."

# Construct request, upload file to JIRA, and print response [200 PASS]
post(url,files=files,headers=headers)

# Close open file
f.close()

print "File upload complete!"
